CREATE TABLE client
(
    id   INTEGER GENERATED BY DEFAULT AS IDENTITY NOT NULL,
    name VARCHAR(100)                             NOT NULL,
    CONSTRAINT pk_client PRIMARY KEY (id)
);

CREATE TABLE item
(
    id          INTEGER GENERATED BY DEFAULT AS IDENTITY NOT NULL,
    description VARCHAR(255),
    price       INTEGER CHECK (price >= 0)               NOT NULL,
    amount      INTEGER CHECK (amount >= 0)              NOT NULL,
    order_id    INTEGER,
    CONSTRAINT pk_item PRIMARY KEY (id)
);

CREATE TABLE "order"
(
    id         INTEGER GENERATED BY DEFAULT AS IDENTITY NOT NULL,
    client_id  INTEGER,
    date       date,
    count_item INTEGER CHECK (count_item >= 0)          NOT NULL,
    CONSTRAINT pk_order PRIMARY KEY (id)
);

ALTER TABLE item
    ADD CONSTRAINT FK_ITEM_ON_ORDER FOREIGN KEY (order_id) REFERENCES "order" (id);

ALTER TABLE "order"
    ADD CONSTRAINT FK_ORDER_ON_CLIENT FOREIGN KEY (client_id) REFERENCES client (id);
